/**
 * Copyright (C) (2010-2018) Vadim Biktashev, Irina Biktasheva et al. 
 * (see ../AUTHORS for the full list of contributors)
 *
 * This file is part of Beatbox.
 *
 * Beatbox is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Beatbox is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beatbox.  If not, see <http://www.gnu.org/licenses/>.
 */

/* Parameters that are definable in bbs and changeable in dialogue */

/* _(Type,Name,Init,reRead,reView,reLight,reMake,reDraw) */
_(int,imin,1,		0,0,0,1,1) /* 3D          */
_(int,imax,S->nx,       0,0,0,1,1) /*   subset    */
_(int,jmin,1,		0,0,0,1,1) /*   of        */
_(int,jmax,S->ny,       0,0,0,1,1) /*   the box   */
_(int,kmin,1,		0,0,0,1,1) /*   to be     */
_(int,kmax,S->nz,       0,0,0,1,1) /*   displayed */

_(int,norm_res,1,	0,0,0,1,1) /* view and run mode resolution */
_(int,rot_res,1,	0,0,0,1,1) /* rotate mode resolution */

_(int,show_surface,1,	0,0,0,0,1) /* whether to draw the surface */
_(int,ulayer,0,		0,0,0,1,1) /* isosurface channel in input files */
_(real,uc,0,		0,0,0,1,1) /* isosurface critical value */
_(int,rlayer,0,		0,0,0,1,1) /* red       channel in input files */
_(real,rmin,0,		0,0,0,1,1) /* red       range lower end */
_(real,rmax,1,		0,0,0,1,1) /* red       range upper end */
_(int,glayer,0,		0,0,0,1,1) /* green     channel in input files */
_(real,gmin,0,		0,0,0,1,1) /* green     range lower end */
_(real,gmax,1,		0,0,0,1,1) /* green     range upper end */
_(int,blayer,0,		0,0,0,1,1) /* blue      channel in input files */
_(real,bmin,0,		0,0,0,1,1) /* blue      range lower end */
_(real,bmax,1,		0,0,0,1,1) /* blue      range upper end */
_(int,alayer,0,		0,0,0,1,1) /* alpha     channel in input files */
_(real,amin,0,		0,0,0,1,1) /* alpha     range lower end */
_(real,amax,1,		0,0,0,1,1) /* alpha     range upper end */

_(int,color_mode,1,	0,0,0,1,1) /* surface colouring algorithm */
_(real,alphamin,0,	0,0,0,1,1) /* minimal opaqueness */
_(real,alphamax,0,	0,0,0,1,1) /* maximal opaqueness */

_(int,show_filament,0,	0,0,0,1,1) /* whether to draw filaments */
_(int,layer1,0,		0,0,0,1,1) /* sing layer 1 */
_(real,const1,0,	0,0,0,1,1) /* sing const 1 */
_(int,layer2,0,		0,0,0,1,1) /* sing layer 2 */
_(real,const2,0,	0,0,0,1,1) /* sing const 2 */
_(real,flm_r,1,		0,0,0,1,1) /* filament          */
_(real,flm_g,1,		0,0,0,1,1) /*    colour         */
_(real,flm_b,0.8,	0,0,0,1,1) /*    components     */
_(real,flm_wt,3.0,	0,0,0,1,1) /*    and the linewidth */
_(int,flm_balls,0,	0,0,0,1,1) /* "", plot it by spheres once=1 or twice=2 */
_(real,flm_em,0,	0,0,0,1,1) /* emission property */

_(real,theta,0,		0,1,0,0,1) /* view angle: rotation about z axis */
_(real,phi,0,		0,1,0,0,1) /* view angle: elevation about z=0 plane */
_(real,psi,0,		0,1,0,0,1) /* view angle: rotation around view line */
_(real,distance,5.0,	0,1,0,0,1) /* former DISTANCE of ezgraph3d.h */

_(int,remove_backs,0,	0,0,0,1,1) /* remove (positive/negative/none) part of surface */
_(int,clipping,0,	0,0,0,0,1) /* use the extra clipping plane */
_(int,ezdepth,1,	0,0,0,0,1) /* use the depth buffer */

_(int,write_images,0,	0,0,0,0,0) /* save all images */
_(int,write_filament,0,	0,0,0,0,0) /* write all filament data */

_(real,bg_r,0.0,	0,0,0,0,1) /* background        */
_(real,bg_g,0.0,	0,0,0,0,1) /*    colour         */
_(real,bg_b,0.0,	0,0,0,0,1) /*    components     */
_(real,bbox_r,0.5,	0,0,0,0,1) /* bounding box      */
_(real,bbox_g,0.5,	0,0,0,0,1) /*    colour         */
_(real,bbox_b,0.5,	0,0,0,0,1) /*    components,    */
_(real,bbox_a,0.5,	0,0,0,0,1) /*    its transparency */
_(real,bbox_wt,2.0,	0,0,0,0,1) /*    and the linewidth */

_(int,verbose,1,	0,0,0,0,0) /* verbosity level */
_(int,autostart,1,	0,0,0,0,0) /* autostart flag */

_(real,lightx,-50.0,	0,0,1,0,1) /* position  */
_(real,lighty,+10.0,	0,0,1,0,1) /*   of the */
_(real,lightz,+10.0,	0,0,1,0,1) /*   directional */
_(real,lightw,1,	0,0,1,0,1) /*   light */
_(real,amb_r,0.5,	0,0,1,0,1) /* color */
_(real,amb_g,0.5,	0,0,1,0,1) /*   of the */
_(real,amb_b,0.5,	0,0,1,0,1) /*   ambient */
_(real,amb_a,0.5,	0,0,1,0,1) /*   light */

#if MARKER
_(int,show_marker,0,	0,0,0,1,1) /* whether to show the marker */
_(real,marker_size,0,	0,0,0,0,1) /* size and             */
_(real,marker_x,xmax/2-1,0,0,0,0,1)/*    coordinates       */
_(real,marker_y,ymax/2-1,0,0,0,0,1)/*    of the marker     */
_(real,marker_z,zmax/2-1,0,0,0,0,1)/*    position          */
_(real,marker_r,1.0,	0,0,0,0,1) /* marker               */
_(real,marker_g,1.0,	0,0,0,0,1) /*    colour            */
_(real,marker_b,0.0,	0,0,0,0,1) /*    components,       */
_(real,marker_a,1,	0,0,0,0,1) /*    its transparency  */
_(real,marker_wt,2.0,	0,0,0,0,1) /*    and the linewidth */
#endif
